package cn.com.qmth.scancentral.controller.admin;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.UserService;
import cn.com.qmth.scancentral.vo.AuditorVo;
import cn.com.qmth.scancentral.vo.CreateCountVo;
import cn.com.qmth.scancentral.vo.UpdateCountVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "审核员管理接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/admin/auditor")
@Aac(strict = false, auth = true)
public class AuditorController extends BaseController {

    @Autowired
    private UserService userService;

    @ApiOperation(value = "审核员列表")
    @PostMapping("list")
    public List<AuditorVo> list() {
        User user = getAccessUser();
        return userService.findAuditor(user.getSchoolId());
    }

    @ApiOperation(value = "审核员修改密码")
    @PostMapping("password")
    public UpdateCountVo password(@RequestParam List<Long> id, @RequestParam String password) {
        return userService.updatePassword(id, password);
    }

    @ApiOperation(value = "批量创建审核员")
    @PostMapping("create")
    public CreateCountVo create(@RequestParam String prefix, @RequestParam Integer count,
            @RequestParam String password) {
        User user = getAccessUser();
        return userService.create(user.getSchoolId(),prefix, count, password);
    }

}