package cn.com.qmth.scancentral.task.thread;

import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.AnswerCardService;
import com.qmth.boot.core.concurrent.service.ConcurrentService;
import com.qmth.boot.core.exception.StatusException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CardSyncThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(CardSyncThread.class);

    private User user;

    private Long examId;

    private AnswerCardService answerCardService;

    private ConcurrentService concurrentService;

    public CardSyncThread(User user, Long examId, AnswerCardService answerCardService,
            ConcurrentService concurrentService) {
        this.examId = examId;
        this.user = user;
        this.answerCardService = answerCardService;
        this.concurrentService = concurrentService;
    }

    @Override
    public void run() {
        if (examId == null) {
            return;
        }
        if (user == null) {
            return;
        }
        try {
            if (concurrentService.getLock(LockType.CARD_SYNC + "-" + examId).tryLock()) {
                answerCardService.sync(user, examId);
            }
        } catch (Exception e) {
            log.error("card sync error", e);
            throw new StatusException("卡格式同步失败");
        } finally {
            concurrentService.getLock(LockType.CARD_SYNC + "-" + examId).unlock();
        }
    }

}
