package cn.com.qmth.scancentral.task.thread;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.qmth.boot.core.concurrent.model.Semaphore;
import com.qmth.boot.core.concurrent.service.ConcurrentService;

import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.StudentAnswerGroupService;

public class StudentAnswerGroupDeleteThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(StudentAnswerGroupDeleteThread.class);

    private Long groupId;

    private StudentAnswerGroupService groupService;

    private ConcurrentService concurrentService;

    private Semaphore semaphore;

    public StudentAnswerGroupDeleteThread(Long groupId, StudentAnswerGroupService groupService,
            ConcurrentService concurrentService, Semaphore semaphore) {
        this.groupId = groupId;
        this.groupService = groupService;
        this.concurrentService = concurrentService;
        this.semaphore = semaphore;
    }

    @Override
    public void run() {
        try {
            log.info("StudentAnswerGroup[" + groupId + "] delete start");
            concurrentService.getLock(LockType.STUDENT_ANSWER_GROUP + "-" + groupId).lock();
            groupService.deleteById(groupId);
            log.info("StudentAnswerGroup[" + groupId + "] delete finish");
        } catch (Exception e) {
            log.error("StudentAnswerGroup[" + groupId + "] delete error", e);
        } finally {
            concurrentService.getLock(LockType.STUDENT_ANSWER_GROUP + "-" + groupId).unlock();
            semaphore.release();
        }
    }

}
