CREATE TABLE IF NOT EXISTS `sc_student`
(
    `id`                 bigint      NOT NULL AUTO_INCREMENT,
    `exam_id`            bigint      NOT NULL,
    `exam_number`        varchar(64) NOT NULL,
    `student_code`       varchar(64) NOT NULL,
    `name`               varchar(64) NOT NULL,
    `subject_code`       varchar(64) NOT NULL,
    `package_code`       varchar(64) DEFAULT NULL,
    `exam_site`          varchar(64) DEFAULT NULL,
    `exam_site_name`     varchar(64) DEFAULT NULL,
    `exam_room`          varchar(64) DEFAULT NULL,
    `seat_number`        varchar(16) DEFAULT NULL,
    `campus_name`        varchar(64) DEFAULT NULL,
    `campus_code`        varchar(64) DEFAULT NULL,
    `status`             varchar(16) NOT NULL,
    `omr_absent`         bit(1)      NOT NULL,
    `question_filled`    bit(1)      NOT NULL,
    `subjective_filled`  bit(1)      NOT NULL,
    `assigned`           bit(1)      NOT NULL,
    `absent_suspect`     bit(1)      NOT NULL,
    `incomplete`         bit(1)      NOT NULL,
    `card_number`        int         DEFAULT NULL,
    `device`             varchar(32) DEFAULT NULL,
    `paper_type`         varchar(16) NOT NULL,
    `exam_status`        varchar(32) DEFAULT NULL,
    `breach_code`        varchar(32) DEFAULT NULL,
    `file_upload_status` varchar(16) DEFAULT NULL,
    `data_upload_status` varchar(16) DEFAULT NULL,
    `check_mark`		 bit(1)      NOT NULL,
    `assigned_check_count` int       DEFAULT NULL,
    `assigned_suspect`	 bit(1)      NOT NULL,
    `creator_id`         bigint      DEFAULT NULL,
    `updater_id`         bigint      DEFAULT NULL,
    `create_time`        bigint      DEFAULT NULL,
    `update_time`        bigint      DEFAULT NULL,
    PRIMARY KEY (`id`),
    UNIQUE KEY `exam_number` (`exam_id`, `exam_number`),
    KEY `exam_student_subject` (`exam_id`, `student_code`, `subject_code`),
    KEY `exam_assigned` (`exam_id`, `assigned`, `assigned_check_count`)
) ENGINE = InnoDB
  DEFAULT CHARSET = utf8mb4;